<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Named Linear Inequality</TITLE>
<link href="suifmath_19.html" rel=Next>
<link href="suifmath_17.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_17.html">previous</A>, <A HREF="suifmath_19.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC18" HREF="suifmath_toc.html#TOC18">Named Linear Inequality</A></H2>
<P>
<A NAME="IDX391"></A>

</P>
<P>
The named linear inequality (class <CODE>named_lin_ineq</CODE>) is a
composition of two parts,
a name table (section <A HREF="suifmath_17.html#SEC17">Name Table</A>) and a system of linear inequalities
(section <A HREF="suifmath_9.html#SEC9">Linear Inequality Library</A>). 
<A NAME="IDX392"></A>

</P>

<P>
The following are functions and operations available for
<CODE>named_lin_ineq</CODE>. In this list of functions, 
symbols <CODE>nli</CODE>, <CODE>nli1</CODE>, <CODE>nli2</CODE> are named linear inequalities,
the symbol <CODE>ptr_nli</CODE> is a pointer to a named linear inequality,
symbols <CODE>nt</CODE> and <CODE>nt1</CODE> are name tables,
symbol <CODE>nte</CODE> is a name table entry,
<CODE>i</CODE> and <CODE>j</CODE> are integers, 
symbol <CODE>leq</CODE> is a <CODE>lin_ineq</CODE> and 
<CODE>im</CODE> is an <CODE>immed</CODE>.

</P>
<DL COMPACT>

<DT><CODE>named_lin_ineq nli();</CODE>
<DD>
Creates an empty named linear inequality.
<A NAME="IDX393"></A>

<DT><CODE>named_lin_ineq nli(nli1);</CODE>
<DD>
<DT><CODE>nli.init(nli1);</CODE>
<DD>
Duplicates the named linear inequality <CODE>nli1</CODE>.
<A NAME="IDX394"></A>
<A NAME="IDX395"></A>

<DT><CODE>named_lin_ineq nli(nt, leq);</CODE>
<DD>
The names are taken from <STRONG>nt</STRONG> and the system of inequalities are
taken from <STRONG>leq</STRONG>.  Note that the number of columns in <STRONG>leq</STRONG>
should match the number of elements in <STRONG>nt</STRONG>.
<A NAME="IDX396"></A>

<DT><CODE>nt = nli.names();</CODE>
<DD>
<DT><CODE>leq = nli.ineqs();</CODE>
<DD>
Get the name part or the linear inequality system part of the named
linear inequality.
<A NAME="IDX397"></A>
<A NAME="IDX398"></A>

<DT><CODE>i = nli.m();</CODE>
<DD>
<DT><CODE>i = nli.n();</CODE>
<DD>
<CODE>m()</CODE> is the number of inequalities and <CODE>n()</CODE> is the number of
variables plus one (for the constant term) in the system.
<A NAME="IDX399"></A>
<A NAME="IDX400"></A>

<DT><CODE>nli.swap_col(i, j);</CODE>
<DD>
Swap the columns <STRONG>i</STRONG> and <STRONG>j</STRONG>.  Both the name table and the
system of inequalities are changed.
<A NAME="IDX401"></A>

<DT><CODE>nli.add_col(nte, i);</CODE>
<DD>
Add the given name at the <STRONG>i</STRONG>th column. A blank column is added to the
system of inequalities.
<A NAME="IDX402"></A>

<DT><CODE>nli.del_col(i);</CODE>
<DD>
<DT><CODE>nli.del_col(i, j);</CODE>
<DD>
Delete the column(s).  Both the names and the entries in the system of
inequalities are deleted.
<A NAME="IDX403"></A>
<A NAME="IDX404"></A>

<DT><CODE>i = nli.find(im);</CODE>
<DD>
Find the column of the variable with the name <STRONG>im</STRONG>.  If the variable
is not in the system return -1.
<A NAME="IDX405"></A>

<DT><CODE>nli = nli2;</CODE>
<DD>
<DT><CODE>nli = leq;</CODE>
<DD>
Copy the named linear inequalities.  When the linear inequality <STRONG>leq</STRONG> is
given for the RHS, only the system of inequalities in <STRONG>nli</STRONG> is
updated.  The columns in <STRONG>leq</STRONG> should match the elements in
<STRONG>nli</STRONG>. 
<A NAME="IDX406"></A>

<DT><CODE>nli1 || nli2;</CODE>
<DD>
<DT><CODE>named_lin_ineq::align_named_lin_ineqs(nli1, nli2);</CODE>
<DD>
<DT><CODE>nli.align(nt);</CODE>
<DD>
Align two named linear inequalities. 
<A NAME="IDX407"></A>
<A NAME="IDX408"></A>

<DT><CODE>boolean isa = named_lin_ineq::is_aligned(nli1, nli2);</CODE>
<DD>
Check if two inqualities are already aligned.
<A NAME="IDX409"></A>

<DT><CODE>nli = nli1 &#38; nli2;</CODE>
<DD>
<DT><CODE>nli &#38;= nli1;</CODE>
<DD>
Intersect the two systems of inequalities by combining the two systems
of inequalities together. Before performing the intersection, the two
inequalities are aligned.
<A NAME="IDX410"></A>
<A NAME="IDX411"></A>

<DT><CODE>boolean del1, del2;</CODE>
<DD>
<DT><CODE>ptr_nli = named_lin_ineq::and(ptr_nli1, ptr_nli2, del1, del2);</CODE>
<DD>
A simplified function to intersect systems of inequalities when one or
more systems may not exist (NULL pointers).  The flags are used to do
memory management. For example if <STRONG>del1</STRONG> is TRUE and <STRONG>ptr_nli1</STRONG>
is not NULL, then that named linear inequality will be deleated.
<A NAME="IDX412"></A>

<DT><CODE>nli &#38;= leq;</CODE>
<DD>
Perform intersection assuming that <STRONG>leq</STRONG> is already aligned with
<STRONG>nli</STRONG>.
<A NAME="IDX413"></A>

<DT><CODE>nli.project();</CODE>
<DD>
<A NAME="IDX414"></A>
<A NAME="IDX415"></A>
Project the system of inequalities using Fourier-Motzkin elimination to
reduce extra inequalities. 

<DT><CODE>nli.project_away(nt);</CODE>
<DD>
<DT><CODE>nli.project_away(im);</CODE>
<DD>
Project away a given variable from the system of inequalities using
Fourier-Motzkin elemination.
<A NAME="IDX416"></A>
<A NAME="IDX417"></A>
<A NAME="IDX418"></A>

<DT><CODE>boolean isempty = ~nli;</CODE>
<DD>
Performs Fourier-Motzkin elimination with Branch-and-Bound to find if an
integer solution exists for the system.  Returns TRUE if no integer
solution. 
<A NAME="IDX419"></A>
<A NAME="IDX420"></A>
<A NAME="IDX421"></A>
<A NAME="IDX422"></A>

<DT><CODE>boolean iseq = (nli1 == nli2);</CODE>
<DD>
Returns TRUE if both systems represent identical convex polyhedrons.
<A NAME="IDX423"></A>

<DT><CODE>boolean isin = (nli1 &#60;&#60; nli2);</CODE>
<DD>
<DT><CODE>boolean isin = (nli2 &#62;&#62; nli1);</CODE>
<DD>
Returns TRUE if the contex polyhedron of <STRONG>nli1</STRONG> is contained in the
contex polyhedron of <STRONG>nli2</STRONG>.
<A NAME="IDX424"></A>
<A NAME="IDX425"></A>
<A NAME="IDX426"></A>

<DT><CODE>array_info ai;</CODE>
<DD>
<DT><CODE>access_vector av;</CODE>
<DD>
<DT><CODE>boolean lb;</CODE>
<DD>
<DT><CODE>immed ind;</CODE>
<DD>
<DT><CODE>ptr_nli = named_lin_ineq::mk_named_lin_ineq(ai, ind, lb);</CODE>
<DD>
<DT><CODE>ptr_nli = named_lin_ineq::mk_named_lin_ineq(av, ind, lb);</CODE>
<DD>
Convert the linear expressions of array bounds and access functions
to a named linear inequality.  If the access function is a linear
expression <STRONG>f()</STRONG> and <STRONG>lb</STRONG> is TRUE, <CODE>mk_named_lin_ineq()</CODE>
will create a named linear inequality representing <CODE> f() &#60;= ind</CODE>,
and if <STRONG>lb</STRONG> is FALSE, <CODE> lind &#60;= f()</CODE>. 
<A NAME="IDX427"></A>
<A NAME="IDX428"></A>
<A NAME="IDX429"></A>
<A NAME="IDX430"></A>
<A NAME="IDX431"></A>
<A NAME="IDX432"></A>

<DT><CODE>instruction * in;</CODE>
<DD>
<DT><CODE>in = nli.mk_bounds();</CODE>
<DD>
Convert the system of inequalities directly to a SUIF 
expression, i.e. construct a SUIF expression tree which will return
TRUE when executed with a set of values of the variables that satisfy
the system of inequalities.  This can be incorporated as the test of a
SUIF IF conditional.
<A NAME="IDX433"></A>
<A NAME="IDX434"></A>

<DT><CODE>instruction * in;</CODE>
<DD>
<DT><CODE>boolean is_ub;</CODE>
<DD>
<DT><CODE>base_symtab * sym_tab;</CODE>
<DD>
<DT><CODE>in = nli.create_expression(v, is_ub)</CODE>
<DD>
<DT><CODE>in = nli.create_expression(v, is_ub, symb_tab)</CODE>
<DD>
Find the set of constraints of the system which are upper (or lower)
bounds of the variable <STRONG>v</STRONG> and create a SUIF expression that
will calculate the bound value.  This is extensively used to produce
bounds when generating loop nests to iterate over a convex polyhedron
defined by a system of inequalities.
<A NAME="IDX435"></A>
<A NAME="IDX436"></A>

<DT><CODE>immed_list iml;</CODE>
<DD>
<DT><CODE>named_lin_ineq nli(iml);</CODE>
<DD>
<DT><CODE>iml = nli.cvt_immed_list()</CODE>
<DD>
Convert to (from) a named linear inequality from (to) an
<CODE>immed_list</CODE>. This is used to store a named linear inequality as an
annotation so that the information can be transferred between passes.
<A NAME="IDX437"></A>
<A NAME="IDX438"></A>
<A NAME="IDX439"></A>

<DT><CODE>nli.cleanup();</CODE>
<DD>
Performs general clean-up such as removing unused names and inequalities
that are always true.
<A NAME="IDX440"></A>

<DT><CODE>nli.print_exp();</CODE>
<DD>
<DT><CODE>nli.print();</CODE>
<DD>
Print the named linear inequality in the matrix format or as
expressions. 
<A NAME="IDX441"></A>
<A NAME="IDX442"></A>

<DT><CODE>tree_for * tf;</CODE>
<DD>
<DT><CODE>ptr_nli = include_for(tf);</CODE>
<DD>
<DT><CODE>ptr_nli = include_for(tf, ptr_nli);</CODE>
<DD>
Generate a named linear inequality to represent the iterations of the
loop.  If the optional pointer is valid, that named linear inequality is
added to the result. The dependence library command
<CODE>fill_in_access()</CODE>  needs to be run on the <CODE>tree_proc</CODE> before
using <CODE>include_for</CODE>.
<A NAME="IDX443"></A>
<A NAME="IDX444"></A>
<A NAME="IDX445"></A>

</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_17.html">previous</A>, <A HREF="suifmath_19.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
